Summary: AmiExpress-style BBS software
Name: daydream
Version: 2.11
Release: 1
Group: Applications/Communications
Source: daydream-2.11.tar.gz
Copyright: GPL

Buildroot: /var/tmp/%{name}-root

%description
DayDream is a bulletin board software.

%package data
Summary: Default configuration and design files for DayDream
Group: Applications/Communications

%description data
These files provide default outlook and configuration for DayDream.

%prep
%setup
%build
sh configure
make

%install
RPM_BUILD=1 make DESTDIR=$RPM_BUILD_ROOT install
rm -rf $RPM_BUILD_ROOT/home/bbs/daydream
ln -sf /home/bbs/bin/daydream $RPM_BUILD_ROOT/home/bbs/daydream
mkdir -p $RPM_BUILD_ROOT/etc/profile.d
install -m 755 $RPM_SOURCE_DIR/daydream.sh $RPM_BUILD_ROOT/etc/profile.d

%clean
rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/useradd bbs >/dev/null 2>&1
/usr/bin/passwd -d bbs 

%post 
cd /home/bbs
if [ -r daydream.cfg ]; then
  bin/ddcfg daydream.cfg
else
  echo Remember to run \"ddcfg\".
fi

%post data
cd /home/bbs
bin/ddcfg daydream.cfg

%files
%defattr(-,bbs,bbs)
/etc/profile.d/daydream.sh
/home/bbs/bin/*
/home/bbs/sbin/*
/home/bbs/lib/*
/home/bbs/daydream
%dir /tmp/dd
%dir /home/bbs/batch
%dir /home/bbs/bulletins
%dir /home/bbs/configs
%dir /home/bbs/data
%dir /home/bbs/display
%dir /home/bbs/questionnaire
%dir /home/bbs/share/batch
%dir /home/bbs/share/bulletins
%dir /home/bbs/share/configs
%dir /home/bbs/share/data
%dir /home/bbs/share/display
%dir /home/bbs/share/questionnaire
/home/bbs/doors
%dir /home/bbs/logfiles
/home/bbs/scripts
%dir /home/bbs/temp
%dir /home/bbs/users
/home/bbs/utils
%doc /home/bbs/docs

%files -f data-filelist data
%defattr(-,bbs,bbs)
